﻿using System.Runtime.InteropServices;
using Microsoft.VisualStudio.Shell;
using PowerGUIVsx.UserInterface;
using QuestSoftware.PowerGUIVsx;

namespace PowerGUIVsx
{
    [Guid("875EC473-34B0-487B-BE57-3BF054A31F38")]
    public class InputOutputToolWindow : ToolWindowPane
    {
        /// <summary>
        /// Standard constructor for the tool window.
        /// </summary>
        public InputOutputToolWindow() :
            base(null)
        {
            // Set the window title reading it from the resources.
            this.Caption = "PowerGUI Console";
            
            // Set the image that will appear on the tab of the window frame
            // when docked with an other window
            // The resource ID correspond to the one defined in the resx file
            // while the Index is the offset in the bitmap strip. Each image in
            // the strip being 16x16.
            this.BitmapResourceID = 302;
            this.BitmapIndex = 0;

            // This is the user control hosted by the tool window; Note that, even if this class implements IDisposable,
            // we are not calling Dispose on this object. This is because ToolWindowPane calls Dispose on 
            // the object returned by the Content property.
            base.Content = new InputOutputWindowWrapper();
        }

        public object InputOutputWindow { get; private set; }
    }
}
