/***************************************************************************

Copyright (c) Microsoft Corporation. All rights reserved.
This code is licensed under the Visual Studio SDK license terms.
THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.

***************************************************************************/

using System;
using System.ComponentModel;
using PowerGUIVsx;

namespace Microsoft.VisualStudio.Project.Samples.CustomProject
{
	[AttributeUsage(AttributeTargets.All)]
	internal sealed class ResourcesDescriptionAttribute : DescriptionAttribute
	{
		#region Fields
		private bool replaced;
		#endregion

		#region Constructors
		/// <summary>
		/// Public constructor.
		/// </summary>
		/// <param name="description">Attribute description.</param>
		public ResourcesDescriptionAttribute(string description)
			: base(description)
		{
		}
		#endregion

		#region Overriden Implementation
		/// <summary>
		/// Gets attribute description.
		/// </summary>
		public override string Description
		{
			get
			{
				if(!replaced)
				{
					replaced = true;
					DescriptionValue = Resources.ResourceManager.GetString(base.Description);
				}

				return base.Description;
			}
		}
		#endregion
	}
}